import ctypes
import os

# TODO:
# function getArch() {
#     const arch = process.arch;
# if (arch == "x64") return "amd64";
# if (arch == "x32") return "i386";
# return arch;
# }
#
# function getOS() {
# const os = process.platform;
# if (os == "win32") return "windows";
# return os;
# }
#
# const pf = `inigo-${getOS()}-${getArch()}`;
# var ext = ".so" // Linux
#
# if (getOS() == "windows") {
# ext = ".dll"
# }
#
# if (getOS() == "darwin") {
# ext = ".dylib"
# }
# // const ffi = Library(resolve(__dirname, `../${pf}/${pf}${ext}`), {

# library = ctypes.cdll.LoadLibrary('/Users/nkaploni/repos/inigo/go/inigo.so')


curr_path = os.path.dirname(os.path.realpath(__file__))
library = ctypes.cdll.LoadLibrary(curr_path + '/inigo.so')

# Inigo config
class Config(ctypes.Structure):
    _fields_ = [
        ('debug', ctypes.c_bool),
        ('ingest', ctypes.c_char_p),
        ('service', ctypes.c_char_p),
        ('token', ctypes.c_char_p),
        ('schema', ctypes.c_char_p),
        ('introspection', ctypes.c_char_p)
    ]


# create
create = library.create
create.argtypes = [ctypes.POINTER(Config)]
create.restype = ctypes.c_uint64

# process_request
process_request = library.process_request
process_request.argtypes = [
    ctypes.c_uint64,                                                # instance
    ctypes.c_char_p, ctypes.c_int,                                  # header
    ctypes.c_char_p, ctypes.c_int,                                  # input
    ctypes.POINTER(ctypes.c_char_p), ctypes.POINTER(ctypes.c_int),  # output
    ctypes.POINTER(ctypes.c_char_p), ctypes.POINTER(ctypes.c_int),  # status
]
process_request.restype = ctypes.c_uint64

# process_response
process_response = library.process_response
process_response.argtypes = [
    ctypes.c_uint64,                                                # instance
    ctypes.c_uint64,                                                # request handler
    ctypes.POINTER(ctypes.c_char), ctypes.c_int,                    # input
    ctypes.POINTER(ctypes.c_char_p), ctypes.POINTER(ctypes.c_int),  # output
]
process_response.restype = None

# ingest_query_data
ingest_query_data = library.ingest_query_data
ingest_query_data.argtypes = [
    ctypes.c_uint64,    # instance
    ctypes.c_uint64     # request handler
]
ingest_query_data.restype = None

# update_schema
update_schema = library.update_schema
update_schema.argtypes = [
    ctypes.c_uint64,    # instance
    ctypes.c_char_p     # input
]
update_schema.restype = ctypes.c_bool

# get_version
get_version = library.get_version
get_version.argtypes = None
get_version.restype = ctypes.c_char_p   # version

# disposeHandle
disposeHandle = library.disposeHandle
disposeHandle.argtypes = [
    ctypes.c_uint64     # request handler
]
disposeHandle.restype = None

# disposeMemory
disposeMemory = library.disposeMemory
disposeMemory.argtypes = [
    ctypes.c_void_p
]
disposeMemory.restype = None
