import setuptools

with open("README.md", "r", encoding="utf-8") as fh:
    long_description = fh.read()

setuptools.setup(
    name='inigo-py',
    version='0.0.1',                                        # TODO: needs to match the current released version, needs to match Inigo version also ?
    author='Nikolai Kaploniuk',
    author_email='nkaploniuk@inigo.io',
    description='Inigo Middleware',
    long_description=long_description,                      # loads your README.md
    long_description_content_type="text/markdown",          # README.md is of type 'markdown'
    url='https://github.com/kolia-kaploniuk/inigo-py',      # TODO: change to inigo repo
    project_urls={                                          # TODO: add Inigo support URL
        "Bug Tracker": "https://github.com/kolia-kaploniuk/inigo-py/issues",
    },
    license='MIT',
    packages=['inigo-py'],
    install_requires=['os', 'ctypes', 'json', 'typings', 'django'],
    classifiers=[                                           # https://pypi.org/classifiers/
        'Development Status :: 2 - Pre-Alpha',
        'Framework :: Django',                              # TODO: specific compatible version
        'License :: OSI Approved :: MIT License',            # TODO: add Environment classifier
        'Typing :: Typed',
    ],
    package_data={
        '': ['*.so']
    },
    download_url='https://github.com/kolia-kaploniuk/inigo-py/archive/refs/tags/v0.0.2.tar.gz', # TODO: also keep the version here updated
)